REM update upKeeperSOS
REM update 20200325, rofo

REM SET 
SET EXCLUDELang=%~dp0exclusion_list.txt
SET WPE=C:\Program Files (x86)\Windows Kits\10\Assessment and Deployment Kit\Windows Preinstallation Environment\amd64
SET WDPTOOLS=C:\Program Files (x86)\Windows Kits\10\Assessment and Deployment Kit\Deployment Tools\amd64
SET PACKAGE=C:\Program Files (x86)\Windows Kits\10\Assessment and Deployment Kit\Windows Preinstallation Environment\amd64\WinPE_OCs\
SET DISMFolder=C:\Program Files (x86)\Windows Kits\10\Assessment and Deployment Kit\Deployment Tools\amd64\DISM\
SET SOSNAME=upKeeperSOS_w10_amd64
SET MOUNT=%~dp0mount
SET DEFAULT=%~dp0

REM Create Folder
if not exist "%mount%" md "%MOUNT%" 
if not exist "%DEFAULT%\Drivers" md "%DEFAULT%\Drivers" 
if not exist "%DEFAULT%%SOSNAME%\Sources" md "%DEFAULT%%SOSNAME%\Sources"

REM Cleanup
"%WDPTOOLS%\dism\dism.exe" /Cleanup-Wim


REM copy org wim file

xcopy "%WPE%\Media" "%DEFAULT%%SOSNAME%" /Y /E  /EXCLUDE:%EXCLUDELang%
xcopy "%WPE%\en-US\winPe.wim"  "%DEFAULT%%SOSNAME%\sources\" /Y
move "%DEFAULT%%SOSNAME%\sources\winpe.wim" "%DEFAULT%%SOSNAME%\sources\boot.wim"

REM mount wim file
"%WDPTOOLS%\dism\dism.exe" /mount-wim /wimfile:"%DEFAULT%%SOSNAME%\sources\boot.wim" /mountdir:"%MOUNT%" /index:1

REM change Language settings
rem %WDPTOOLS%\dism\dism.exe /Set-AllIntl:en-US /Image:"%MOUNT%"

REM Change scratch space, default is 512
REM %WDPTOOLS%\dism\dism.exe /Set-ScratchSpace:1024 /Image:"%MOUNT%"


REM copy upKeeper files
xcopy "%DEFAULT%\upKeeper\"* "%MOUNT%\Windows\system32" /Y /C
xcopy "%WDPTOOLS%\dism\"ima*.* "%MOUNT%\Windows\system32" /Y /C

REM install feature

"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-NetFx.cab"
"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-WMI.cab"
"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-PowerShell.cab"
"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-Dot3Svc.cab"


"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-NetFx_en-us.cab"
"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-WMI_en-us.cab"
"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-PowerShell_en-us.cab"
"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-Dot3Svc_en-us.cab"


REM Bitlocker
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-EnhancedStorage.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-StorageWMI.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-SecureBootCmdlets.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-SecureStartup.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%WinPE-DismCmdlets.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-SecureStartup_en-us.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-DismCmdlets_en-us.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-EnhancedStorage.cab"
REM "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /add-package /packagepath:"%PACKAGE%en-us\WinPE-StorageWMI.cab"

if not exist "%MOUNT%\Windows\system32\en-US" md "%MOUNT%\Windows\system32\en-US"
xcopy C:\upkeeper\update_SOS\bitlocker\* "%MOUNT%\Windows\system32\en-US" /Y

rem Add language
rem "%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /set-inputlocale:sv-SE


REM Add drivers to upkeeperSOS
"%WDPTOOLS%\dism\dism.exe" /image:"%MOUNT%" /Add-Driver /driver:"%DEFAULT%\drivers" /recurse
if not %errorlevel%==0 PAUSE

REM Install KB

REM install update to winPE
rem "%WDPTOOLS%\dism\dism.exe" /Add-Package /Image:"%MOUNT%" /PackagePath:"windows10.0-kbxxxxx.msu"

REM Add WindowsSetupComplete
md "%MOUNT%\windows\system32\SetupComplete"
xcopy %~dp0SetupComplete\*.* "%MOUNT%\windows\system32\SetupComplete" /Y


REM cleanup 
md "%default%\temp"
"%WDPTOOLS%\dism\dism.exe" /cleanup-image /image:%MOUNT% /startcomponentcleanup /resetbase /scratchdir:"%default%\temp"


REM unmount wim file.
"%WDPTOOLS%\dism\dism.exe" /unmount-wim /mountdir:"%MOUNT%" /commit
REM Create ISO
"%WDPTOOLS%\Oscdimg\Oscdimg.exe" -n -b"%WDPTOOLS%\Oscdimg\etfsboot.com" "%DEFAULT%%SOSNAME%" "%DEFAULT%%SOSNAME%.iso"
"%WDPTOOLS%\Oscdimg\Oscdimg.exe" -n -b"%WDPTOOLS%\Oscdimg\efisys.bin" "%DEFAULT%%SOSNAME%" "%DEFAULT%%SOSNAME%_UEFI.iso"
pause